"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function formatUnit(unit) {
    var sorted = sortDimensions(unit);
    if (sorted.length === 0) {
        return "";
    }
    return " " + sorted.map(formatDimension).join(" * ");
}
exports.formatUnit = formatUnit;
function sortDimensions(unit) {
    var dimensions = [];
    for (var dimension in unit) {
        var symbolAndExponent = unit[dimension];
        if (symbolAndExponent === undefined) {
            continue;
        }
        var exponent = symbolAndExponent[1];
        if (exponent !== 0) {
            dimensions.push(symbolAndExponent);
        }
    }
    dimensions.sort(function (_a, _b) {
        var leftSymbol = _a[0];
        var rightSymbol = _b[0];
        if (leftSymbol < rightSymbol) {
            return -1;
        }
        return 1;
    });
    return dimensions;
}
function formatDimension(_a) {
    var symbol = _a[0], exponent = _a[1];
    var exponentStr = exponent !== 1 ? "^" + exponent : "";
    return "" + symbol + exponentStr;
}
//# sourceMappingURL=format.js.map