import { Exponent } from "../exponent";
import { BaseUnit, DivideUnits, ExponentiateUnit, MultiplyUnits, NthRootUnit, RadicandUnit, Unit, UnitWithSymbols } from "./types";
export declare function dimension<D extends string>(dim: D, symbol?: string): UnitWithSymbols<{
    [K in D]: 1;
}>;
export declare function multiplyUnits<L extends Unit, R extends Unit>(left: UnitWithSymbols<L>, right: UnitWithSymbols<R>): UnitWithSymbols<MultiplyUnits<L, R>>;
export declare function divideUnits<L extends Unit, R extends Unit>(left: UnitWithSymbols<L>, right: UnitWithSymbols<R>): UnitWithSymbols<DivideUnits<L, R>>;
export declare function exponentiateUnit<U extends BaseUnit<N>, N extends Exponent>(unit: UnitWithSymbols<U>, power: N): UnitWithSymbols<ExponentiateUnit<U, N>>;
export declare function nthRootUnit<U extends RadicandUnit<N>, N extends Exponent>(unit: UnitWithSymbols<U>, root: N): UnitWithSymbols<NthRootUnit<U, N>>;
