"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var exponent_1 = require("../exponent");
function dimension(dim, symbol) {
    var _a;
    // TODO Remove cast to any somehow
    return _a = {}, _a[dim] = [symbol || dim, 1], _a;
}
exports.dimension = dimension;
function multiplyUnits(left, right) {
    var result = {};
    for (var dimension_1 in left) {
        var symbolAndExponent = copySymbolAndExponent(left, dimension_1);
        if (symbolAndExponent !== undefined) {
            result[dimension_1] = symbolAndExponent;
        }
    }
    for (var dimension_2 in right) {
        var symbolAndExponent = copySymbolAndExponent(right, dimension_2);
        if (symbolAndExponent === undefined) {
            continue;
        }
        var exponent = symbolAndExponent[1];
        var resultValue = result[dimension_2];
        if (resultValue !== undefined) {
            var newExponent = resultValue[1] + exponent;
            if (isExponent(newExponent)) {
                resultValue[1] = newExponent;
            }
            else {
                throw new Error(exponent_1.ArithmeticError);
            }
        }
        else {
            result[dimension_2] = symbolAndExponent;
        }
    }
    for (var dimension_3 in result) {
        var value = result[dimension_3];
        if (value !== undefined && value[1] === 0) {
            delete result[dimension_3];
        }
    }
    return result;
}
exports.multiplyUnits = multiplyUnits;
function copySymbolAndExponent(unit, dimension) {
    var result = unit[dimension];
    if (result === undefined) {
        return undefined;
    }
    var symbol = result[0], exponent = result[1];
    return [symbol, exponent];
}
function divideUnits(left, right) {
    // TODO Remove cast to any somehow
    return multiplyUnits(left, exponentiateUnit(right, -1));
}
exports.divideUnits = divideUnits;
function exponentiateUnit(unit, power) {
    return expAndRootImpl(unit, function (exponent) { return exponent * power; });
}
exports.exponentiateUnit = exponentiateUnit;
function nthRootUnit(unit, root) {
    return expAndRootImpl(unit, function (exponent) { return exponent / root; });
}
exports.nthRootUnit = nthRootUnit;
function expAndRootImpl(unit, updateExponent) {
    var result = {};
    for (var dimension_4 in unit) {
        var symbolAndExponent = unit[dimension_4];
        if (symbolAndExponent === undefined) {
            continue;
        }
        var symbol = symbolAndExponent[0], exponent = symbolAndExponent[1];
        var newExponent = updateExponent(exponent);
        if (isExponent(newExponent)) {
            if (newExponent !== 0) {
                result[dimension_4] = [symbol, newExponent];
            }
        }
        else {
            throw new Error(exponent_1.ArithmeticError);
        }
    }
    return result;
}
function isExponent(exp) {
    return exp >= exponent_1.MinExponent && exp <= exponent_1.MaxExponent && Math.floor(exp) === exp;
}
//# sourceMappingURL=units.js.map